plot.grandaverage <- function(data) {
  # mean
  data.all <- with(data, aggregate(uV, by=list(AoAGroup, Structure, Correctness, Time), mean))
  names(data.all) <- c("Group", "Structure", "Correctness", "Time", "uV")

  # sd
  data.all2 <- with(data, aggregate(uV, by=list(AoAGroup, Structure, Correctness, Time), sd))
  names(data.all2) <- c("Group", "Structure", "Correctness", "Time", "uV.sd")
  data.all <- merge(data.all,data.all2,by=c("Group","Structure","Correctness","Time"))

  # plots
  #x11()
  par(mfrow=c(2,3))
  for (struc in levels(as.factor(data.all$Structure))) {
	  
	  for (grp in levels(as.factor(data.all$Group))) {
	  
		rng <- data.all[data.all$Structure == struc & data.all$Group == grp,]
		
		#confidence intervals for correct
		rngc <- rng[rng$Correctness == 'cor',]
		temp <- dat[dat$AoAGroup==grp & dat$Structure==struc & dat$Correctness == 'cor',] # to get n for sderr
		rngc$uV.sderr <- rngc$uV.sd / sqrt(nlevels(droplevels(temp$Word))*nlevels(droplevels(temp$Subject)))
		rngc$uV.lower <- rngc$uV - 1.96*rngc$uV.sderr
		rngc$uV.upper <- rngc$uV + 1.96*rngc$uV.sderr
		mx <- max(rngc$uV.upper)
		mn <- min(rngc$uV.lower)
  
		#confidence intervals for incorrect
		rngi <- rng[rng$Correctness != 'cor',]
		temp <- dat[dat$AoAGroup==grp & dat$Structure==struc & dat$Correctness != 'cor',] # to get n for sderr
		rngi$uV.sderr <- rngi$uV.sd / sqrt(nlevels(droplevels(temp$Word))*nlevels(droplevels(temp$Subject)))
		rngi$uV.lower <- rngi$uV - 1.96*rngi$uV.sderr
		rngi$uV.upper <- rngi$uV + 1.96*rngi$uV.sderr
		mx <- max(mx,rngi$uV.upper)
		mn <- min(mn,rngi$uV.lower)
  
		#plot cor
		rngc <- rngc[order(rngc$Time),]
		plot(rngc$Time,rngc$uV,col='darkgreen',type='l',ylim=c(8,-3),lwd=2,xlab='Time (ms.)', ylab='uV', main=paste(struc,grp))
		polygon(c(rngc$Time,rev(rngc$Time)),c(rngc$uV.upper,rev(rngc$uV.lower)),
				col=rgb(0,1,0,alpha=.25),border=NA) # shaded confidence interval
  
		#plot incor
		rngi <- rngi[order(rngi$Time),]
		lines(rngi$Time,rngi$uV,col='red',lwd=2)
		polygon(c(rngi$Time,rev(rngi$Time)),c(rngi$uV.upper,rev(rngi$uV.lower)),
				col=rgb(1,0,0,alpha=.25),border=NA) # shaded confidence interval
    
		abline(h=0,lty=3)
		abline(v=0,lty=3)
	  }
  }
}
